/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * const gridColModel = {}	: 화면 Grid Object			*
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 *******************************************************/

/*화면 변수*/
const STOCKMNG03010_GRID_ID = '#ITP_STOCKMNG03010_jqGrid';
const STOCKMNG03010_GRID_LIST = '#ITP_STOCKMNG03010_jqGrid_list';
const STOCKMNG03010_GRID_PAGER = '#ITP_STOCKMNG03010_jqGridPager';
const STOCKMNG03010_GRID_EMPTY = '#ITP_STOCKMNG03010_jqGridEmpty';

let ITP_FORM_STOCKMNG03010_IS_DUPLICATE = false;
let ITP_FORM_STOCKMNG03010_IS_WRITING = false;
let STOCKMNG03010_GRID_LAST_ROW_ID;

/*API URL*/
let STOCK_BASE_MNG_DETAIL_GRID_LIST = '/api/stock/base/mng/detail-grid-list';
let WHS_MNG_DETAIL_GRID_LIST = '/api/whs/mng/detail-grid-list';
let WHS_MNG_LOCATION_GRID_LIST = '/api/whs/mng/location-grid-list';
let STOCK_BASE_MNG_SAVE = '/api/stock/base/mng/save';

/*화면 Grid ColModel*/
const gridColModel = {
	list: [
		{
			index: 'VIEW_CD', name: 'viewCd',
			label: ITP_MSG_LOCALE.label.viewCd,
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'BRAND_ID', name: 'brandId',
			label: "브랜드ID", 
			width: '0', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'LOCATION', name: 'location',
			label: "로케이션", 
			width: '0', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'BRAND_NM', name: 'brandNm',
			label: ITP_MSG_LOCALE.label.brandNm, //브랜드
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'STORE_NM', name: 'storeNm',
			label: "매장명", 
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'WHS_ID', name: 'whsId',
			label: "창고번호", 
			width: '8', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'WHS_NM', name: 'whsNm',
			label: "창고명", 
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'LOCATION_NM', name: 'locationNm',
			label: "Location명", 
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ITEM_ID', name: 'itemId',
			label: "품목번호", 
			width: '11', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ITEM_NM', name: 'itemNm',
			label: "품목명", 
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'UNIT', name: 'unit',
			label: "단위", 
			width: '7', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'PRP_STCK_QTY', name: 'prpStckQty',
			label: "적정재고수량", 
			width: '8', fixed: false, align: 'center',
			sortable: false, editable: true, edittype: 'text',
			editrules: {required: false}
		},
		{
			index: 'SFT_STCK_RT', name: 'sftStckRt',
			label: "안전재고비율(%)", 
			width: '10', fixed: false, align: 'center',
			sortable: false, editable: true, edittype: 'text',
			editrules: {required: false}
		}		
	]
};

require(['config'], function() {
	require([
	], function($) {
		pageObj.init();
	});
});

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.ui.init();
		this.event.init();
	},
	ui: {
		init: function () {
			this.view();
			this.grid();
			this.ready();
		},
		view: function() {
			// 버튼 권한설정
			fn_proc_btn_auth('STOCKMNG03010');
			
			// 브랜드ID 지정
			var data = JSON.parse(sessionStorage.getItem('itp_manage_brand_info'));
			$('#ITP_FORM_STOCKMNG03010_SEARCH_BRAND_ID').val(data.brandId);
			
			pageObj.fnWhsList(function() {
				pageObj.fnLocationList();
			}); // 창고리스트
			
			// 공통코드 표시
			// fn_make_select(CODE_LIST, 'WHS_DVSN', 'ITP_FORM_STOCKMNG03010_WHS_DVSN');			

			// 조회일자 지정
			$('#ITP_TAB_STOCKMNG03010 .input-group.date').datepicker(ITP_DATE_LANGUAGE);			
		},
		grid: function() {
			itp_fn_jqgrid_resize(STOCKMNG03010_GRID_ID, STOCKMNG03010_GRID_LIST, 'lg');
			listObj.empty.init();
			itp_fn_fire_window_resize();
		},
		ready: function() {
			listObj.init();
		}
	},
	event: {
		init: function () {
			this.button();
			this.change();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_STOCKMNG03010_SRH'		: listObj.button.search();		break;	// 조회 버튼
						case 'ITP_BTN_STOCKMNG03010_SAVE'		: listObj.button.save();		break;	// 저장 버튼
					}
				});
			});

			$('body').on('click', function(e) {
				var gridId = STOCKMNG03010_GRID_ID.replace('#', '');
				var rids = $(STOCKMNG03010_GRID_ID).jqGrid('getDataIDs');
				var last_row_id = rids[rids.length - 1];
				itp_fn_grid_reset_selection(e, last_row_id, gridId, 'STOCKMNG03010');
			});
		}, 
		change: function () {
			// 창고 변경
			$('#ITP_FORM_STOCKMNG03010_SEARCH_WHS_ID').on('change', function() {
				pageObj.fnLocationList(function() {
					listObj.button.search(); // 조회	
				}); // 로케이션 리스트
			});
			$('#ITP_FORM_STOCKMNG03010_SEARCH_LOCATION').on('change', function() {
				listObj.button.search(); // 조회
			});
			
		}
	},
	switchScreen: function(mode) {
		if(mode == 'LIST') { // 목록			
			fn_show_btn_auth('#ITP_BTN_STOCKMNG03010_SRH');

			$('#ITP_AJAX_STOCKMNG03010_LIST_CONTAINER').show();
		}
	}, 
	fnWhsList: function(fnCall) {
		const brandIdVal = $('#ITP_FORM_STOCKMNG03010_SEARCH_BRAND_ID').val();	
		const param = {sbrandId: brandIdVal, pagingYn: false};
		
		fn_ajax_call(WHS_MNG_DETAIL_GRID_LIST, JSON.stringify(param), function(result) {
			
			fn_make_select_whs(result.gridRows, 'ITP_FORM_STOCKMNG03010_SEARCH_WHS_ID');
			
			if (fnCall !== undefined || typeof fnCall !== 'undefined') fnCall();
					
		}, 'POST');
	}, 
	fnLocationList: function(fnCall) {
		const brandIdVal = $('#ITP_FORM_STOCKMNG03010_SEARCH_BRAND_ID').val();	
		const whsIdVal = $('#ITP_FORM_STOCKMNG03010_SEARCH_WHS_ID').val();	
		const param = {brandId: brandIdVal, whsId: whsIdVal, pagingYn: false};
		
		fn_ajax_call(WHS_MNG_LOCATION_GRID_LIST, JSON.stringify(param), function(result) {
			
			fn_make_select_location(result.gridRows, 'ITP_FORM_STOCKMNG03010_SEARCH_LOCATION');
			
			if (fnCall !== undefined || typeof fnCall !== 'undefined') fnCall();
					
		}, 'POST');
	}
};

/*목록화면 Object*/
let listObj = {
	init: function () {
		this.grid.init();
	},
	itp_STOCKMNG03010_search: false,
	button: {
		search: function() {
			listObj.itp_STOCKMNG03010_search = true;
			let param = $('#ITP_FORM_STOCKMNG03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(STOCKMNG03010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		}, 
		save: function() {
			$('#ITP_FORM_STOCKMNG03010_WHS_ID').val($('#ITP_FORM_STOCKMNG03010_SEARCH_WHS_ID').val());
			$('#ITP_FORM_STOCKMNG03010_LOCATION').val($('#ITP_FORM_STOCKMNG03010_SEARCH_LOCATION').val());
			
			const formId = '#ITP_FORM_STOCKMNG03010';
			itp_fn_form_clear_validate(null, formId);
			
			let gridUpdateData = [];
			const rowData = $(STOCKMNG03010_GRID_ID).getRowData();			
			if(rowData.length < 1) {
				itp_fn_modal_alert_ajax(ITP_MSG_LOCALE.message.grid.noData);
				return;
			}	
			$.each(rowData, function(key, value) {
				if (value.viewCd != 'R') {
					if (value.viewCd == 'U') {
						gridUpdateData.push(value);
					} 
				}
			});
			if(gridUpdateData.length < 1) {
				itp_fn_modal_alert_ajax('변경된 데이터가 없습니다.');
				return;
			}
			let param = $(formId).serializeObject();			
			param.gridUpdateData = gridUpdateData;
			//console.log(JSON.stringify(param));
			var searhFn = function() {
				ITP_FORM_STOCKMNG03010_DETAIL_IS_WRITING = false;
				listObj.grid.search();
			};
			fn_ajax_call(STOCK_BASE_MNG_SAVE, JSON.stringify(param), searhFn, 'POST');
		}
	},
	empty: {
		init: function() {
			var _this = this;
			this.push();
			$(STOCKMNG03010_GRID_EMPTY).on('click', function() {
				_this.back();
				_this.itp_STOCKMNG03010_param.gridSize = $.jgrid.defaults.rowNum;
				$(STOCKMNG03010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_STOCKMNG03010_param)}).trigger('reloadGrid');
			});
		},
		itp_STOCKMNG03010_param: {},
		push: function() {
			let param = $('#ITP_FORM_STOCKMNG03010_SEARCH').serializeObject();
			listObj.itp_STOCKMNG03010_param = param;
		},
		back: function() {
			$('#ITP_FORM_STOCKMNG03010_DEVI_TP_CD').val(this.itp_STOCKMNG03010_param.deviTpCd);
			$('#ITP_FORM_STOCKMNG03010_ORDER_YN').val(this.itp_STOCKMNG03010_param.orderYn);
			$('#ITP_FORM_STOCKMNG03010_ADT_AUTH_CD').val(this.itp_STOCKMNG03010_param.adtAuthCd);
			$('#ITP_FORM_STOCKMNG03010_EMAIL_RCV_YN').val(this.itp_STOCKMNG03010_param.emailRcvYn);
			$('#ITP_FORM_STOCKMNG03010_MEMB_EXIT_DT').val(this.itp_STOCKMNG03010_param.membExitDt);
			$('#ITP_FORM_STOCKMNG03010_FROM_DT').val(this.itp_STOCKMNG03010_param.fromDt);
			$('#ITP_FORM_STOCKMNG03010_TO_DT').val(this.itp_STOCKMNG03010_param.toDt);
			$('#ITP_FORM_STOCKMNG03010_KEYWORD').val(this.itp_STOCKMNG03010_param.keyword);
		}
	},
	grid: {
		init: function () {
			// 데이터 없을때
			listObj.empty.push();
			this.search();
		},
		colModel: gridColModel.list,
		search: function() {
			pageObj.switchScreen('LIST');
			this.unload();
			this.load();
		},
		load: function() {
			var data = JSON.parse(sessionStorage.getItem('itp_manage_brand_info'));
			$('#ITP_FORM_STOCKMNG03010_BRAND_ID').val(data.brandId);
			$('#ITP_FORM_STOCKMNG03010_SEARCH_BRAND_ID').val(data.brandId);
			
			let param = $('#ITP_FORM_STOCKMNG03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;

			var option = {
				gridId: STOCKMNG03010_GRID_ID,
				colModel: gridColModel.list,
				param: JSON.stringify(param),
				url: DOMAIN + STOCK_BASE_MNG_DETAIL_GRID_LIST,
				pager: STOCKMNG03010_GRID_PAGER,
				onCellSelect: function(rowId, cellIdx, cellValue) {
					STOCKMNG03010_GRID_LAST_ROW_ID = itp_fn_set_data_editable(rowId, cellIdx, STOCKMNG03010_GRID_LAST_ROW_ID, STOCKMNG03010_GRID_ID); 
		   		},
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, STOCKMNG03010_GRID_ID, true, 'number', 'STOCKMNG03010', listObj.itp_STOCKMNG03010_search, listObj.empty, true, data.gridRecords, true);
					var ids = $(STOCKMNG03010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						// $(STOCKMNG03010_GRID_ID).jqGrid('setCell', rowId, 'whsNm', '', ITP_GRID_COL_STYLE.link);
					});
				},
				onPaging: function(action) {
					itp_fn_grid_paging(STOCKMNG03010_GRID_ID, action, param);
				}
			};
			itp_fn_grid_make_remote(option);
		},
		clearData : function() {
			$(STOCKMNG03010_GRID_ID).jqGrid('clearGridData', true);
			$(STOCKMNG03010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(STOCKMNG03010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(STOCKMNG03010_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(STOCKMNG03010_GRID_ID);
		}
	}
};
